]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Better handling of stdout and stderr
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Notmuch helper functions
217 increment_mtime_amount=0
218 increment_mtime ()
219 {
220     dir="$1"
221
222     increment_mtime_amount=$((increment_mtime_amount + 1))
223     touch -d "+${increment_mtime_amount} seconds" "$dir"
224 }
225
226 # Generate a new message in the mail directory, with a unique message
227 # ID and subject. The message is not added to the index.
228 #
229 # After this function returns, the filename of the generated message
230 # is available as $gen_msg_filename and the message ID is available as
231 # $gen_msg_id .
232 #
233 # This function supports named parameters with the bash syntax for
234 # assigning a value to an associative array ([name]=value). The
235 # supported parameters are:
236 #
237 #  [dir]=directory/of/choice
238 #
239 #       Generate the message in directory 'directory/of/choice' within
240 #       the mail store. The directory will be created if necessary.
241 #
242 #  [filename]=name
243 #
244 #       Store the message in file 'name'. The default is to store it
245 #       in 'msg-<count>', where <count> is three-digit number of the
246 #       message.
247 #       
248 #  [body]=text
249 #
250 #       Text to use as the body of the email message
251 #
252 #  '[from]="Some User <user@example.com>"'
253 #  '[to]="Some User <user@example.com>"'
254 #  '[subject]="Subject of email message"'
255 #  '[date]="RFC 822 Date"'
256 #
257 #       Values for email headers. If not provided, default values will
258 #       be generated instead.
259 #
260 #  '[cc]="Some User <user@example.com>"'
261 #  [reply-to]=some-address
262 #  [in-reply-to]=<message-id>
263 #  [references]=<message-id>
264 #  [content-type]=content-type-specification
265 #  '[header]=full header line, including keyword'
266 #
267 #       Additional values for email headers. If these are not provided
268 #       then the relevant headers will simply not appear in the
269 #       message.
270 #
271 #  '[id]=message-id'
272 #
273 #       Controls the message-id of the created message.
274 gen_msg_cnt=0
275 gen_msg_filename=""
276 gen_msg_id=""
277 generate_message ()
278 {
279     # This is our (bash-specific) magic for doing named parameters
280     local -A template="($@)"
281     local additional_headers
282
283     gen_msg_cnt=$((gen_msg_cnt + 1))
284     if [ -z "${template[filename]}" ]; then
285         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
286     else
287         gen_msg_name=${template[filename]}
288     fi
289
290     if [ -z "${template[id]}" ]; then
291         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
292     else
293         gen_msg_id="${template[id]}"
294     fi
295
296     if [ -z "${template[dir]}" ]; then
297         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
298     else
299         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
300         mkdir -p "$(dirname "$gen_msg_filename")"
301     fi
302
303     if [ -z "${template[body]}" ]; then
304         template[body]="This is just a test message (#${gen_msg_cnt})"
305     fi
306
307     if [ -z "${template[from]}" ]; then
308         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
309     fi
310
311     if [ -z "${template[to]}" ]; then
312         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
313     fi
314
315     if [ -z "${template[subject]}" ]; then
316         template[subject]="Test message #${gen_msg_cnt}"
317     fi
318
319     if [ -z "${template[date]}" ]; then
320         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
321     fi
322
323     additional_headers=""
324     if [ ! -z "${template[header]}" ]; then
325         additional_headers="${template[header]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[reply-to]}" ]; then
330         additional_headers="Reply-To: ${template[reply-to]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[in-reply-to]}" ]; then
335         additional_headers="In-Reply-To: ${template[in-reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[cc]}" ]; then
340         additional_headers="Cc: ${template[cc]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[references]}" ]; then
345         additional_headers="References: ${template[references]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[content-type]}" ]; then
350         additional_headers="Content-Type: ${template[content-type]}
351 ${additional_headers}"
352     fi
353
354
355 cat <<EOF >"$gen_msg_filename"
356 From: ${template[from]}
357 To: ${template[to]}
358 Message-Id: <${gen_msg_id}>
359 Subject: ${template[subject]}
360 Date: ${template[date]}
361 ${additional_headers}
362 ${template[body]}
363 EOF
364
365     # Ensure that the mtime of the containing directory is updated
366     increment_mtime "$(dirname "${gen_msg_filename}")"
367 }
368
369 # Generate a new message and add it to the database.
370 #
371 # All of the arguments and return values supported by generate_message
372 # are also supported here, so see that function for details.
373 add_message ()
374 {
375     generate_message "$@" &&
376     notmuch new > /dev/null
377 }
378
379 # Generate a corpus of email and add it to the database.
380 #
381 # This corpus is fixed, (it happens to be 50 messages from early in
382 # the history of the notmuch mailing list), which allows for reliably
383 # testing commands that need to operate on a not-totally-trivial
384 # number of messages.
385 add_email_corpus ()
386 {
387     rm -rf ${MAIL_DIR}
388     if [ -d ../corpus.mail ]; then
389         cp -a ../corpus.mail ${MAIL_DIR}
390     else
391         cp -a ../corpus ${MAIL_DIR}
392         notmuch new >/dev/null
393         cp -a ${MAIL_DIR} ../corpus.mail
394     fi
395 }
396
397 test_begin_subtest ()
398 {
399     test_subtest_name="$1"
400     # Remember stdout and stderr file descriptios and redirect test
401     # output to the previously prepared file descriptors 3 and 4 (see
402     # bellow)
403     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
404     exec 6>&1 7>&2 >&3 2>&4
405 }
406
407 # Pass test if two arguments match
408 #
409 # Note: Unlike all other test_expect_* functions, this function does
410 # not accept a test name. Instead, the caller should call
411 # test_begin_subtest before calling this function in order to set the
412 # name.
413 test_expect_equal ()
414 {
415         exec 1>&6 2>&7          # Restore stdout and stderr
416         test "$#" = 3 && { prereq=$1; shift; } || prereq=
417         test "$#" = 2 ||
418         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
419
420         output="$1"
421         expected="$2"
422         if ! test_skip "$@"
423         then
424                 if [ "$output" = "$expected" ]; then
425                         test_ok_ "$test_subtest_name"
426                 else
427                         testname=$this_test.$test_count
428                         echo "$expected" > $testname.expected
429                         echo "$output" > $testname.output
430                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
431                 fi
432     fi
433 }
434
435 test_expect_equal_failure ()
436 {
437         test "$#" = 3 && { prereq=$1; shift; } || prereq=
438         test "$#" = 2 ||
439         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
440
441         output="$1"
442         expected="$2"
443         if ! test_skip "$@"
444         then
445                 if [ "$output" = "$expected" ]; then
446                         test_known_broken_ok_ "$test_subtest_name"
447                 else
448                         test_known_broken_failure_ "$test_subtest_name"
449                 fi
450     fi
451 }
452
453 NOTMUCH_NEW ()
454 {
455     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
456 }
457
458 notmuch_search_sanitize ()
459 {
460     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
461 }
462
463 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
464 notmuch_show_sanitize ()
465 {
466     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
467 }
468
469 # End of notmuch helper functions
470
471 # Use test_set_prereq to tell that a particular prerequisite is available.
472 # The prerequisite can later be checked for in two ways:
473 #
474 # - Explicitly using test_have_prereq.
475 #
476 # - Implicitly by specifying the prerequisite tag in the calls to
477 #   test_expect_{success,failure,code}.
478 #
479 # The single parameter is the prerequisite tag (a simple word, in all
480 # capital letters by convention).
481
482 test_set_prereq () {
483         satisfied="$satisfied$1 "
484 }
485 satisfied=" "
486
487 test_have_prereq () {
488         case $satisfied in
489         *" $1 "*)
490                 : yes, have it ;;
491         *)
492                 ! : nope ;;
493         esac
494 }
495
496 # You are not expected to call test_ok_ and test_failure_ directly, use
497 # the text_expect_* functions instead.
498
499 test_ok_ () {
500         test_success=$(($test_success + 1))
501         say_color pass "%-6s" "PASS"
502         echo " $@"
503 }
504
505 test_failure_ () {
506         test_failure=$(($test_failure + 1))
507         say_color error "%-6s" "FAIL"
508         echo " $1"
509         shift
510         echo "$@" | sed -e 's/^/        /'
511         if test "$verbose" != "t"; then cat test.output; fi
512         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
513 }
514
515 test_known_broken_ok_ () {
516         test_fixed=$(($test_fixed+1))
517         say_color pass "%-6s" "FIXED"
518         echo " $@"
519 }
520
521 test_known_broken_failure_ () {
522         test_broken=$(($test_broken+1))
523         say_color pass "%-6s" "BROKEN"
524         echo " $@"
525 }
526
527 test_debug () {
528         test "$debug" = "" || eval "$1"
529 }
530
531 test_run_ () {
532         test_cleanup=:
533         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
534         eval >&3 2>&4 "$1"
535         eval_ret=$?
536         eval >&3 2>&4 "$test_cleanup"
537         return 0
538 }
539
540 test_skip () {
541         test_count=$(($test_count+1))
542         to_skip=
543         for skp in $NOTMUCH_SKIP_TESTS
544         do
545                 case $this_test.$test_count in
546                 $skp)
547                         to_skip=t
548                 esac
549         done
550         if test -z "$to_skip" && test -n "$prereq" &&
551            ! test_have_prereq "$prereq"
552         then
553                 to_skip=t
554         fi
555         case "$to_skip" in
556         t)
557                 say_color skip >&3 "skipping test: $@"
558                 say_color skip "%-6s" "SKIP"
559                 echo " $1"
560                 : true
561                 ;;
562         *)
563                 false
564                 ;;
565         esac
566 }
567
568 test_expect_failure () {
569         test "$#" = 3 && { prereq=$1; shift; } || prereq=
570         test "$#" = 2 ||
571         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
572         if ! test_skip "$@"
573         then
574                 test_run_ "$2"
575                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
576                 then
577                         test_known_broken_ok_ "$1"
578                 else
579                         test_known_broken_failure_ "$1"
580                 fi
581         fi
582 }
583
584 test_expect_success () {
585         test "$#" = 3 && { prereq=$1; shift; } || prereq=
586         test "$#" = 2 ||
587         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
588         if ! test_skip "$@"
589         then
590                 test_run_ "$2"
591                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
592                 then
593                         test_ok_ "$1"
594                 else
595                         test_failure_ "$@"
596                 fi
597         fi
598 }
599
600 test_expect_code () {
601         test "$#" = 4 && { prereq=$1; shift; } || prereq=
602         test "$#" = 3 ||
603         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
604         if ! test_skip "$@"
605         then
606                 test_run_ "$3"
607                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
608                 then
609                         test_ok_ "$2"
610                 else
611                         test_failure_ "$@"
612                 fi
613         fi
614 }
615
616 # test_external runs external test scripts that provide continuous
617 # test output about their progress, and succeeds/fails on
618 # zero/non-zero exit code.  It outputs the test output on stdout even
619 # in non-verbose mode, and announces the external script with "* run
620 # <n>: ..." before running it.  When providing relative paths, keep in
621 # mind that all scripts run in "trash directory".
622 # Usage: test_external description command arguments...
623 # Example: test_external 'Perl API' perl ../path/to/test.pl
624 test_external () {
625         test "$#" = 4 && { prereq=$1; shift; } || prereq=
626         test "$#" = 3 ||
627         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
628         descr="$1"
629         shift
630         if ! test_skip "$descr" "$@"
631         then
632                 # Announce the script to reduce confusion about the
633                 # test output that follows.
634                 say_color "" " run $test_count: $descr ($*)"
635                 # Run command; redirect its stderr to &4 as in
636                 # test_run_, but keep its stdout on our stdout even in
637                 # non-verbose mode.
638                 "$@" 2>&4
639                 if [ "$?" = 0 ]
640                 then
641                         test_ok_ "$descr"
642                 else
643                         test_failure_ "$descr" "$@"
644                 fi
645         fi
646 }
647
648 # Like test_external, but in addition tests that the command generated
649 # no output on stderr.
650 test_external_without_stderr () {
651         # The temporary file has no (and must have no) security
652         # implications.
653         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
654         stderr="$tmp/git-external-stderr.$$.tmp"
655         test_external "$@" 4> "$stderr"
656         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
657         descr="no stderr: $1"
658         shift
659         if [ ! -s "$stderr" ]; then
660                 rm "$stderr"
661                 test_ok_ "$descr"
662         else
663                 if [ "$verbose" = t ]; then
664                         output=`echo; echo Stderr is:; cat "$stderr"`
665                 else
666                         output=
667                 fi
668                 # rm first in case test_failure exits.
669                 rm "$stderr"
670                 test_failure_ "$descr" "$@" "$output"
671         fi
672 }
673
674 # This is not among top-level (test_expect_success | test_expect_failure)
675 # but is a prefix that can be used in the test script, like:
676 #
677 #       test_expect_success 'complain and die' '
678 #           do something &&
679 #           do something else &&
680 #           test_must_fail git checkout ../outerspace
681 #       '
682 #
683 # Writing this as "! git checkout ../outerspace" is wrong, because
684 # the failure could be due to a segv.  We want a controlled failure.
685
686 test_must_fail () {
687         "$@"
688         test $? -gt 0 -a $? -le 129 -o $? -gt 192
689 }
690
691 # test_cmp is a helper function to compare actual and expected output.
692 # You can use it like:
693 #
694 #       test_expect_success 'foo works' '
695 #               echo expected >expected &&
696 #               foo >actual &&
697 #               test_cmp expected actual
698 #       '
699 #
700 # This could be written as either "cmp" or "diff -u", but:
701 # - cmp's output is not nearly as easy to read as diff -u
702 # - not all diff versions understand "-u"
703
704 test_cmp() {
705         $GIT_TEST_CMP "$@"
706 }
707
708 # This function can be used to schedule some commands to be run
709 # unconditionally at the end of the test to restore sanity:
710 #
711 #       test_expect_success 'test core.capslock' '
712 #               git config core.capslock true &&
713 #               test_when_finished "git config --unset core.capslock" &&
714 #               hello world
715 #       '
716 #
717 # That would be roughly equivalent to
718 #
719 #       test_expect_success 'test core.capslock' '
720 #               git config core.capslock true &&
721 #               hello world
722 #               git config --unset core.capslock
723 #       '
724 #
725 # except that the greeting and config --unset must both succeed for
726 # the test to pass.
727
728 test_when_finished () {
729         test_cleanup="{ $*
730                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
731 }
732
733 test_done () {
734         GIT_EXIT_OK=t
735         test_results_dir="$TEST_DIRECTORY/test-results"
736         mkdir -p "$test_results_dir"
737         test_results_path="$test_results_dir/${0%.sh}-$$"
738
739         echo "total $test_count" >> $test_results_path
740         echo "success $test_success" >> $test_results_path
741         echo "fixed $test_fixed" >> $test_results_path
742         echo "broken $test_broken" >> $test_results_path
743         echo "failed $test_failure" >> $test_results_path
744         echo "" >> $test_results_path
745
746         echo
747
748         if [ "$test_failure" = "0" ]; then
749             rm -rf "$remove_tmp"
750             exit 0
751         else
752             exit 1
753         fi
754 }
755
756 test_emacs () {
757         # Construct a little test script here for the benefit of the user,
758         # (who can easily run "run_emacs" to get the same emacs environment
759         # for investigating any failures).    
760         cat <<EOF > run_emacs
761 #!/bin/sh
762 export PATH=$PATH
763 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
764
765 # We assume that the user will give a command-line argument only if
766 # wanting to run in batch mode.
767 if [ \$# -gt 0 ]; then
768         BATCH=--batch
769 fi
770
771 # Here's what we are using here:
772 #
773 # --batch:              Quit after given commands and print all (messages)
774 #
775 # --no-init-file        Don't load users ~/.emacs
776 #
777 # --no-site-file        Don't load the site-wide startup stuff
778 #
779 # --directory           Ensure that the local notmuch.el source is found
780 #
781 # --load                Force loading of notmuch.el
782 #
783 # notmuch-test-wait     Function for tests to use to wait for process completion
784 #
785 # message-signature     Avoiding appending user's signature on messages
786 #
787 # set-frame-width       80 columns (avoids crazy 10-column default of --batch)
788
789 emacs \$BATCH --no-init-file --no-site-file \
790         --directory ../../emacs --load notmuch.el \
791         --eval "(defun notmuch-test-wait ()
792                         (while (get-buffer-process (current-buffer))
793                                 (sleep-for 0.1)))" \
794         --eval "(setq message-signature nil)" \
795         --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
796 EOF
797         chmod a+x ./run_emacs
798         ./run_emacs "$@"
799 }
800
801
802 find_notmuch_path ()
803 {
804     dir="$1"
805
806     while [ -n "$dir" ]; do
807         bin="$dir/notmuch"
808         if [ -x "$bin" ]; then
809             echo "$dir"
810             return
811         fi
812         dir="$(dirname "$dir")"
813         if [ "$dir" = "/" ]; then
814             break
815         fi
816     done
817 }
818
819 # Test the binaries we have just built.  The tests are kept in
820 # test/ subdirectory and are run in 'trash directory' subdirectory.
821 TEST_DIRECTORY=$(pwd)
822 if test -n "$valgrind"
823 then
824         make_symlink () {
825                 test -h "$2" &&
826                 test "$1" = "$(readlink "$2")" || {
827                         # be super paranoid
828                         if mkdir "$2".lock
829                         then
830                                 rm -f "$2" &&
831                                 ln -s "$1" "$2" &&
832                                 rm -r "$2".lock
833                         else
834                                 while test -d "$2".lock
835                                 do
836                                         say "Waiting for lock on $2."
837                                         sleep 1
838                                 done
839                         fi
840                 }
841         }
842
843         make_valgrind_symlink () {
844                 # handle only executables
845                 test -x "$1" || return
846
847                 base=$(basename "$1")
848                 symlink_target=$TEST_DIRECTORY/../$base
849                 # do not override scripts
850                 if test -x "$symlink_target" &&
851                     test ! -d "$symlink_target" &&
852                     test "#!" != "$(head -c 2 < "$symlink_target")"
853                 then
854                         symlink_target=../valgrind.sh
855                 fi
856                 case "$base" in
857                 *.sh|*.perl)
858                         symlink_target=../unprocessed-script
859                 esac
860                 # create the link, or replace it if it is out of date
861                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
862         }
863
864         # override notmuch executable in TEST_DIRECTORY/..
865         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
866         mkdir -p "$GIT_VALGRIND"/bin
867         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
868         OLDIFS=$IFS
869         IFS=:
870         for path in $PATH
871         do
872                 ls "$path"/notmuch 2> /dev/null |
873                 while read file
874                 do
875                         make_valgrind_symlink "$file"
876                 done
877         done
878         IFS=$OLDIFS
879         PATH=$GIT_VALGRIND/bin:$PATH
880         GIT_EXEC_PATH=$GIT_VALGRIND/bin
881         export GIT_VALGRIND
882 else # normal case
883         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
884         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
885 fi
886 export PATH
887
888 # Test repository
889 test="tmp.$(basename "$0" .sh)"
890 test -n "$root" && test="$root/$test"
891 case "$test" in
892 /*) TMP_DIRECTORY="$test" ;;
893  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
894 esac
895 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
896 rm -fr "$test" || {
897         GIT_EXIT_OK=t
898         echo >&5 "FATAL: Cannot prepare test area"
899         exit 1
900 }
901
902 MAIL_DIR="${TMP_DIRECTORY}/mail"
903 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
904
905 mkdir -p "${test}"
906 mkdir -p "${MAIL_DIR}"
907
908 cat <<EOF >"${NOTMUCH_CONFIG}"
909 [database]
910 path=${MAIL_DIR}
911
912 [user]
913 name=Notmuch Test Suite
914 primary_email=test_suite@notmuchmail.org
915 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
916 EOF
917
918
919 # Use -P to resolve symlinks in our working directory so that the cwd
920 # in subprocesses like git equals our $PWD (for pathname comparisons).
921 cd -P "$test" || error "Cannot setup test environment"
922
923 if test "$verbose" = "t"
924 then
925         exec 4>&2 3>&1
926 else
927         exec 4>test.output 3>&4
928 fi
929
930 this_test=${0##*/}
931 for skp in $NOTMUCH_SKIP_TESTS
932 do
933         to_skip=
934         for skp in $NOTMUCH_SKIP_TESTS
935         do
936                 case "$this_test" in
937                 $skp)
938                         to_skip=t
939                 esac
940         done
941         case "$to_skip" in
942         t)
943                 say_color skip >&3 "skipping test $this_test altogether"
944                 say_color skip "skip all tests in $this_test"
945                 test_done
946         esac
947 done
948
949 # Provide an implementation of the 'yes' utility
950 yes () {
951         if test $# = 0
952         then
953                 y=y
954         else
955                 y="$*"
956         fi
957
958         while echo "$y"
959         do
960                 :
961         done
962 }
963
964 # Fix some commands on Windows
965 case $(uname -s) in
966 *MINGW*)
967         # Windows has its own (incompatible) sort and find
968         sort () {
969                 /usr/bin/sort "$@"
970         }
971         find () {
972                 /usr/bin/find "$@"
973         }
974         sum () {
975                 md5sum "$@"
976         }
977         # git sees Windows-style pwd
978         pwd () {
979                 builtin pwd -W
980         }
981         # no POSIX permissions
982         # backslashes in pathspec are converted to '/'
983         # exec does not inherit the PID
984         ;;
985 *)
986         test_set_prereq POSIXPERM
987         test_set_prereq BSLASHPSPEC
988         test_set_prereq EXECKEEPSPID
989         ;;
990 esac
991
992 test -z "$NO_PERL" && test_set_prereq PERL
993 test -z "$NO_PYTHON" && test_set_prereq PYTHON
994
995 # test whether the filesystem supports symbolic links
996 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
997 rm -f y